<?php

namespace Drupal\mcapi_credcom;

use Drupal\mcapi\Event\TransactionSaveEvent;
use Drupal\Component\EventDispatcher\ContainerAwareEventDispatcher;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * Example subscriber showing the two McapiEvents.
 * @deprecated
 */
class TransactionSubscriber implements EventSubscriberInterface {

  /**
   * {@inheritDoc}
   */
  public static function getSubscribedEvents() : array{
    return [
      //McapiEvents::ACTION => ['onTransactionAction']
    ];
  }

  /**
   * Notify the trunkward node of a change in state.
   *
   * @param TransactionSaveEvent $event
   *   $event->getArguments() yields form_values, old_state and operation name,
   *    or action. $events->getSubject() gives the transaction.
   * @param string $eventName
   *   The machine name of the event.
   * @param ContainerAwareEventDispatcher $container
   *   The container.
   */
  public function onTransactionAction(TransactionSaveEvent $event, $eventName, ContainerAwareEventDispatcher $container) {
    $transaction = $event->getSubject();
    [$form_values, $old_state, $op_name] = $event->getArguments();
    switch ($op_name) {
      case 'save':
        $dest_cc_state = $transaction->getWorkflow()->creation->state;
      default:

    }
    try {
      $transaction->set('state', $dest_state);
      $transaction->credCom->changeState(CredCom::MCAPI_CREDCOM_STATE_MAP[$dest_state], TRUE);
    }
    catch (Throwable $e) {
      \Drupal::messenger()->addError(t(
        'There was a problem saving the transaction to the network: @message',
        ['@message' => $e->getMessage()]
      ));
      \Drupal::logger('mcapi_credcom')->notice('@notice', ['@notice' => $e->getMessage()]);
    }
    $event->setMessage("TransactionSubscriber responded to $eventName");
  }

}
