<?php

namespace Drupal\mcapi_limits\Event;

use \Symfony\Component\EventDispatcher\GenericEvent;
use Symfony\Component\Validator\Constraint;

/**
 * Event which is fired whenever the limits constraint prevents a transactions.
 */
class TransactionLimitPreventedEvent extends GenericEvent {

  const EVENT_NAME = 'mcapi_transaction.limit.prevented';

  public function __construct(
    public array $transgressions,
    public Constraint $constraint
  ) {
    $this->subject = $transgressions;
  }

}
