<?php

namespace Drupal\mcapi_limits\Event;

use \Symfony\Component\EventDispatcher\GenericEvent;
use Drupal\mcapi\Entity\Transaction;
use Drupal\mcapi\Entity\Wallet;
use Drupal\mcapi\Entity\Currency;
use Symfony\Component\Validator\Constraint;

/**
 * Event which is fired whenever the limits constraint prevents a transactions.
 */
class TransactionLimitPreventedEvent extends GenericEvent {

  const EVENT_NAME = 'mcapi_transaction.limit.warning';

  public function __construct(
    public Transaction $transaction,
    public Currency $currency,
    public Wallet $wallet,
    public Constraint $constraint,
    public int $balance,
    public int $max,
    public int $projected,
  ) {
    $this->subject = $transaction;
  }

}
