<?php

namespace Drupal\mcapi_limits\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Supports validating payer & payee of parent transactions.
 *
 * @Constraint(
 *   id = "Limits",
 *   label = @Translation("Checks that neither wallet goes beyond its determined credit limits"),
 *   type = "entity:mcapi_transaction"
 * )
 */
class TransactionLimitsConstraint extends Constraint {

  public $message = "The transaction would take wallet '%wallet' %excess beyond the wallet's limit of %limit.";

  /**
   * {@inheritdoc}
   */
  public function coversFields() {
    return ['payer', 'payee', 'worth'];
  }

}
