<?php

namespace Drupal\mcapi\Entity\Query;

use Drupal\Core\Entity\Query\Sql\Query as BaseQuery;

/**
 * Add access control to the wallet query according to the status of the wallet holder.
 * @todo make this work for every type of holder entity based on status of the OwnerEntity.
 */
class WalletQuery extends BaseQuery {

  /**
   * {@inheritDoc}
   *
   * Disallow wallets whose holders are blocked users.
   */
  public function prepare(){
    parent::prepare();
    if ($this->accessCheck) {
      $this->sqlQuery->join(
        'mcapi_wallet__holder',
        'wallet_holder',
        'base_table.wid = wallet_holder.entity_id'
      );
      // Surprisingly (to me) this still allows non-user holders wallets to be displayed
      $this->sqlQuery->join(
        'users_field_data',
        'u',
        'wallet_holder.holder_target_id = u.uid AND u.status = 1'
      );
    }
    return $this;
  }

}
