<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityChangedInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Interface for Transaction entity.
 */
interface TransactionInterface extends ContentEntityInterface, EntityChangedInterface, EntityOwnerInterface {

  /**
   * Load a transaction from its serial number
   *
   * @return Transaction
   */
  public static function loadBySerial(int $serial);

  /**
   * Add children to the transaction.
   *
   * @return Transaction[]
   *   The added child transactions
   *
   * @note this should be called explicitly, and PRIOR to validation, but
   * otherwise is called by validate()
   */
  public function assemble() : array ;

  /**
   * Returns the time that the transaction was created.
   *
   * @return int
   *   The timestamp of when the transaction was created.
   */
  public function getCreatedTime();

}
