<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;

/**
 * Defines the transaction state entity class.
 *
 * @ConfigEntityType(
 *   id = "mcapi_type",
 *   label = @Translation("Transaction type"),
 *   config_prefix = "type",
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "description"
 *   }
 * )
 * @todo make a property to set whether to show this workflow under the default transaction form tabs.
 * @todo make a property to indicate whether this is a local workflow i.e. editable or inherited
 */
class Type extends ConfigEntityBase {

  /**
   * Identifier for the current Type.
   *
   * @var string
   */
  public $id;

  /**
   * Label of the current Type.
   *
   * @var string
   */
  public $label;

  /**
   * Description of the current State.
   *
   * @var string
   */
  public $description;

  public function __toString() {
    return $this->label;
  }

}
