<?php

namespace Drupal\mcapi\Plugin\Action;

use Drupal\mcapi\Plugin\TransactionActionBase;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Confirmation form for creating a transaction.
 *
 * @Action(
 *   id = "mcapi_transaction.save_action",
 *   label = @Translation("Save a transaction to disk"),
 *   type = "mcapi_transaction"
 * )
 */
class Save extends TransactionActionBase {

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);
    $form['states'] = [
      '#type' => 'value',
      '#value' => [],
    ];
    $form['access'] = [
      '#type' => 'value',
      '#value' => ['creator'],
    ];
    return $form;
  }

  /**
   * {@inheritDoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    return $return_as_object ?
      AccessResult::AllowedIf($object->isNew()) :
      $object->isNew();
  }

}
