<?php

namespace Drupal\mcapi\Plugin\views\access;

use Drupal\mcapi\Entity\Wallet;
use Drupal\views\Plugin\views\access\AccessPluginBase;
use Symfony\Component\Routing\Route;
use Drupal\Core\Session\AccountInterface;

/**
 * Access plugin that provides permission-based access control.
 *
 * @ingroup views_access_plugins
 *
 * @ViewsAccess(
 *   id = "mcapi_wallet_holder",
 *   title = @Translation("Wallet holder (deprecated)"),
 *   help = @Translation("Access will be granted to users who hold the wallet of the first argument. Better use the views private wallet argument validator.")
 * )
 */
class WalletHolder extends AccessPluginBase {

  /**
   * {@inheritdoc}
   */
  public function access(AccountInterface $account) {
#    if ($account->hasPermission('view all transactions'))return TRUE;
    $wallet_id = \Drupal::service('current_route_match')->getParameter('mcapi_wallet');
    $wallet = Wallet::load($wallet_id);
    return $wallet->access('update', $account);
  }

  /**
   * {@inheritdoc}
   */
  public function alterRouteDefinition(Route $route) {
    $route->setRequirement('_entity_access', 'mcapi_wallet.update');
  }

  public function summaryTitle() {
    return $this->t('Wallet holder');
  }

}
